'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.createBlessedComponent = createBlessedComponent;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash.upperfirst');

var _lodash2 = _interopRequireDefault(_lodash);

var _blessedContrib = require('blessed-contrib');

var _blessedContrib2 = _interopRequireDefault(_blessedContrib);

var _ReactBlessedComponent = require('react-blessed/dist/ReactBlessedComponent');

var _ReactBlessedComponent2 = _interopRequireDefault(_ReactBlessedComponent);

var _ReactBlessedIDOperations = require('react-blessed/dist/ReactBlessedIDOperations');

var _ReactBlessedIDOperations2 = _interopRequireDefault(_ReactBlessedIDOperations);

var _solveClass = require('react-blessed/dist/solveClass');

var _solveClass2 = _interopRequireDefault(_solveClass);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var blacklist = ['OutputBuffer', 'InputBuffer', 'createScreen', 'serverError', 'grid', 'carousel', 'markdown'];

function createBlessedComponent(blessedElement) {
  var tag = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  return function (_ReactBlessedComponen) {
    _inherits(_class, _ReactBlessedComponen);

    function _class() {
      _classCallCheck(this, _class);

      return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, tag));
    }

    _createClass(_class, [{
      key: 'mountNode',
      value: function mountNode(parent, element) {
        var props = element.props,
            children = props.children,
            options = _objectWithoutProperties(props, ['children']);


        var node = blessedElement((0, _solveClass2.default)(options));

        node.on('event', this._eventListener);
        parent.append(node);

        return node;
      }
    }]);

    return _class;
  }(_ReactBlessedComponent2.default);
}

// Treat Markdown in a special way so that text can be passed as a child content

var Markdown = function (_ReactBlessedComponen2) {
  _inherits(Markdown, _ReactBlessedComponen2);

  function Markdown() {
    _classCallCheck(this, Markdown);

    return _possibleConstructorReturn(this, (Markdown.__proto__ || Object.getPrototypeOf(Markdown)).call(this, 'contrib-markdown'));
  }

  _createClass(Markdown, [{
    key: 'mountNode',
    value: function mountNode(parent, element) {
      var props = element.props,
          children = props.children,
          options = _objectWithoutProperties(props, ['children']);


      var opts = options;
      if (typeof children === 'string' && !opts.markdown) {
        opts.markdown = children;
      }

      var node = _blessedContrib2.default.markdown((0, _solveClass2.default)(opts));

      node.on('event', this._eventListener);
      parent.append(node);

      return node;
    }

    // Override mountComponent so that children are ignored

  }, {
    key: 'mountComponent',
    value: function mountComponent(rootID, transaction, context) {
      this._rootNodeID = rootID;

      // Mounting blessed node
      var node = this.mountNode(_ReactBlessedIDOperations2.default.getParent(rootID), this._currentElement);

      _ReactBlessedIDOperations2.default.add(rootID, node);

      // Rendering the screen
      _ReactBlessedIDOperations2.default.screen.debouncedRender();
    }
  }]);

  return Markdown;
}(_ReactBlessedComponent2.default);

// We stub methods for contrib.grid to let it compute params for us which we then render in the React way


function Grid(props) {
  var grid = new _blessedContrib2.default.grid(_extends({}, props, { screen: { append: function append() {} } }));
  var children = props.children instanceof Array ? props.children : [props.children];
  return _react2.default.createElement(props.component || 'element', {}, children.map(function (child) {
    var props = child.props;
    var options = grid.set(props.row, props.col, props.rowSpan, props.colSpan, function (x) {
      return x;
    }, props.options);
    return _react2.default.cloneElement(child, options);
  }));
}

var GridItem = function (_Component) {
  _inherits(GridItem, _Component);

  function GridItem() {
    _classCallCheck(this, GridItem);

    return _possibleConstructorReturn(this, (GridItem.__proto__ || Object.getPrototypeOf(GridItem)).apply(this, arguments));
  }

  _createClass(GridItem, [{
    key: 'getItem',
    value: function getItem() {
      return this._reactInternalInstance._instance.refs.item;
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;
      return _react2.default.createElement(props.component, _extends({}, props, { ref: 'item' }), props.children);
    }
  }]);

  return GridItem;
}(_react.Component);

// We let the contrib.carousel manage state, re-rendering happens via move method that triggers component update


var Carousel = function (_Component2) {
  _inherits(Carousel, _Component2);

  function Carousel(props) {
    _classCallCheck(this, Carousel);

    var _this4 = _possibleConstructorReturn(this, (Carousel.__proto__ || Object.getPrototypeOf(Carousel)).call(this, props));

    _this4.state = {
      page: 0
    };
    return _this4;
  }

  _createClass(Carousel, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this5 = this;

      this.carousel = new _blessedContrib2.default.carousel(this.props.children, this.props);
      this.carousel.move = function () {
        _this5.setState({
          page: _this5.carousel.currPage
        });
      };
      this.carousel.start();
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children[this.state.page];
    }
  }]);

  return Carousel;
}(_react.Component);

Object.keys(_blessedContrib2.default).forEach(function (key) {
  // todo check prototype
  if (_blessedContrib2.default.hasOwnProperty(key) && blacklist.indexOf(key) === -1) {
    exports[(0, _lodash2.default)(key)] = createBlessedComponent(_blessedContrib2.default[key], 'contrib-' + key);
  }

  exports.Grid = Grid;
  exports.GridItem = GridItem;
  exports.Carousel = Carousel;
  exports.Markdown = Markdown;
});